Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestService.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestService.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestService.java	(revision 5549)
@@ -2,11 +2,12 @@
 
 import clarin.cmdi.componentregistry.AllowedAttributetypesXML;
+import clarin.cmdi.componentregistry.AuthenticationFailException;
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
-import clarin.cmdi.componentregistry.ComponentStatus;
 import clarin.cmdi.componentregistry.DeleteFailedException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
-import clarin.cmdi.componentregistry.Owner;
+import clarin.cmdi.componentregistry.RegistrySpace;
 import clarin.cmdi.componentregistry.UserCredentials;
 import clarin.cmdi.componentregistry.UserUnauthorizedException;
@@ -45,4 +46,5 @@
 import javax.servlet.ServletContext;
 import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
 import javax.ws.rs.Consumes;
 import javax.ws.rs.DELETE;
@@ -72,5 +74,7 @@
 
 /**
- * Handles CRUD operations on {@link ComponentDescription}, {@link ProfileDescription} and {@link Comment}s
+ * Handles CRUD operations on
+ * {@link ComponentDescription}, {@link ProfileDescription} and {@link Comment}s
+ *
  * @author twago@mpi.nl
  * @author olsha@mpi.nl
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/IComponentRegistryRestService.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/IComponentRegistryRestService.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/IComponentRegistryRestService.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.rest;
 
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import java.io.IOException;
 import java.io.InputStream;
@@ -13,5 +14,4 @@
 
 import clarin.cmdi.componentregistry.AllowedAttributetypesXML;
-import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
 import clarin.cmdi.componentregistry.ComponentRegistryFactory;
@@ -44,42 +44,36 @@
 	public static final String GROUP_FORM_FIELD = "group";
 	public static final String DOMAIN_FORM_FIELD = "domainName";
-	public static final String USERSPACE_PARAM = "userspace";
+	public static final String REGISTRY_SPACE_PARAM = "registrySpace";
 	public static final String GROUPID_PARAM = "groupid";
 	public static final String METADATA_EDITOR_PARAM = "mdEditor";
 	public static final String NUMBER_OF_RSSITEMS = "limit";
 
-	List<ComponentDescription> getRegisteredComponents(boolean userspace, String groupId)
-			throws ComponentRegistryException;
-
-	List<ProfileDescription> getRegisteredProfiles(boolean userspace,
-			boolean metadataEditor, String groupId) throws ComponentRegistryException;
-
-	Response getRegisteredComponent(String componentId, boolean userspace)
-			throws ComponentRegistryException;
-
-	Response getRegisteredComponentRawType(String componentId, String rawType);
-
-	ComponentRegistry findRegistry(String id,
-			RegistryClosure<? extends BaseDescription> clos)
-			throws ComponentRegistryException;
-
-	Response getRegisteredProfile(String profileId, boolean userspace)
-			throws ComponentRegistryException;
-
-	List<BaseDescription> getComponentUsage(String componentId,
-			boolean userspace) throws ComponentRegistryException;
-
-	List<Comment> getCommentsFromProfile(String profileId, boolean userspace)
-			throws ComponentRegistryException;
-
-	List<Comment> getCommentsFromComponent(String componentId, boolean userspace)
-			throws ComponentRegistryException;
-
-	Comment getSpecifiedCommentFromProfile(String profileId, String commentId,
-			boolean userspace) throws ComponentRegistryException;
-
-	Comment getSpecifiedCommentFromComponent(String componentId,
-			String commentId, boolean userspace)
-			throws ComponentRegistryException;
+	List<ComponentDescription> getRegisteredComponents(String registrySpace, String groupId)
+			throws ComponentRegistryException, IOException, UserUnauthorizedException;
+
+	List<ProfileDescription> getRegisteredProfiles(String registrySpace, boolean metadataEditor, String groupId) throws ComponentRegistryException, IOException, UserUnauthorizedException;
+
+	Response getRegisteredComponent(String componentId) throws IOException;
+
+	Response getRegisteredProfile(String profileId) throws IOException;
+        
+        Response getRegisteredComponentRawType(String componentId, String rawType) throws ComponentRegistryException;
+
+        
+//	ComponentRegistry findRegistry(String id,
+//			RegistryClosure<? extends BaseDescription> clos)
+//			throws ComponentRegistryException;
+//
+//	
+
+	List<BaseDescription> getComponentUsage(String componentId) throws ComponentRegistryException, IOException;
+
+	List<Comment> getCommentsFromProfile(String profileId) throws ComponentRegistryException, IOException;
+
+	List<Comment> getCommentsFromComponent(String componentId) throws ComponentRegistryException, IOException;
+
+	Comment getSpecifiedCommentFromProfile(String profileId, String commentId) throws ComponentRegistryException, IOException ;
+
+	Comment getSpecifiedCommentFromComponent(String componentId, String commentId) throws ComponentRegistryException, IOException ;
 
 	/**
@@ -92,18 +86,17 @@
 	 * @return
 	 */
-	Response manipulateRegisteredProfile(String profileId, String method,
-			boolean userspace);
+	Response manipulateRegisteredProfile(String profileId, String method);
 
 	Response manipulateCommentFromProfile(String profileId, String commentId,
-			String method, boolean userspace);
+			String method);
 
 	Response manipulateCommentFromComponent(String componentId,
-			String commentId, String method, boolean userspace);
+			String commentId, String method);
 
 	Response publishRegisteredProfile(String profileId, InputStream input,
 			String name, String description, String group, String domainName);
 
-	Response updateRegisteredProfile(String profileId, boolean userspace,
-			InputStream input, String name, String description, String group,
+	Response updateRegisteredProfile(String profileId, 
+			InputStream input, String name, String description, String groupId,
 			String domainName);
 
@@ -117,39 +110,32 @@
 	 * @return
 	 */
-	Response manipulateRegisteredComponent(String componentId, String method,
-			boolean userspace);
+	Response manipulateRegisteredComponent(String componentId, String method);
 
 	Response publishRegisteredComponent(String componentId, InputStream input,
-			String name, String description, String group, String domainName);
-
-	Response updateRegisteredComponent(String componentId, boolean userspace,
-			InputStream input, String name, String description, String group,
+			String name, String description, String groupId, String domainName);
+
+	Response updateRegisteredComponent(String componentId,
+			InputStream input, String name, String description, String groupId,
 			String domainName);
 
-	Response deleteRegisteredComponent(String componentId, boolean userspace);
-
-	Response deleteRegisteredProfile(String profileId, boolean userspace);
-
-	Response deleteCommentFromProfile(String profileId, String commentId,
-			boolean userspace);
-
-	Response deleteCommentFromComponent(String componentId, String commentId,
-			boolean userspace);
-
-	Response getRegisteredProfileRawType(String profileId, String rawType);
+	Response deleteRegisteredComponent(String componentId);
+
+	Response deleteRegisteredProfile(String profileId);
+
+	Response deleteCommentFromProfile(String profileId, String commentId);
+
+	Response deleteCommentFromComponent(String componentId, String commentId);
+
+	Response getRegisteredProfileRawType(String profileId, String rawType) throws ComponentRegistryException;
 
 	Response registerProfile(InputStream input, String name,
-			String description, String group, String domainName,
-			boolean userspace);
+			String description, String groupId, String domainName);
 
 	Response registerComponent(InputStream input, String name,
-			String description, String group, String domainName,
-			boolean userspace);
-
-	Response registerCommentInComponent(InputStream input, String componentId,
-			boolean userspace) throws ComponentRegistryException;
-
-	Response registerCommentInProfile(InputStream input, String profileId,
-			boolean userspace) throws ComponentRegistryException;
+			String description, String groupId, String domainName);
+
+	Response registerCommentInComponent(InputStream input, String componentId) throws ComponentRegistryException;
+
+	Response registerCommentInProfile(InputStream input, String profileId) throws ComponentRegistryException;
 
 	Response pingSession();
@@ -158,6 +144,5 @@
 	 * @param componentRegistryFactory the componentRegistryFactory to set
 	 */
-	void setComponentRegistryFactory(
-			ComponentRegistryFactory componentRegistryFactory);
+	void setComponentRegistryFactory(ComponentRegistryFactory componentRegistryFactory);
 
 	/**
@@ -169,6 +154,6 @@
 	 * @throws ParseException
 	 */
-	Rss getRssComponent(boolean userspace, String limit)
-			throws ComponentRegistryException, ParseException;
+	Rss getRssComponent(String groupId, String registrySpace, String limit)
+			throws ComponentRegistryException, ParseException, IOException;
 
 	/**
@@ -180,6 +165,6 @@
 	 * @throws ParseException
 	 */
-	Rss getRssProfile(boolean userspace, String limit)
-			throws ComponentRegistryException, ParseException;
+	Rss getRssProfile(String groupId, String registrySpace, String limit)
+			throws ComponentRegistryException, ParseException, IOException;
 
 	/**
@@ -194,7 +179,6 @@
 	 * @throws ParseException
 	 */
-	Rss getRssOfCommentsFromProfile(String profileId, boolean userspace,
-			String limit) throws ComponentRegistryException, IOException,
-			JAXBException, ParseException;
+	Rss getRssOfCommentsFromProfile(String profileId, String limit) throws ComponentRegistryException, 
+			JAXBException, ParseException, IOException;
 
 	/**
@@ -209,5 +193,5 @@
 	 * @throws ParseException
 	 */
-	Rss getRssOfCommentsFromComponent(String componentId, boolean userspace,
+	Rss getRssOfCommentsFromComponent(String componentId,
 			String limit) throws ComponentRegistryException, IOException,
 			JAXBException, ParseException;
@@ -237,5 +221,5 @@
 	 * @param groupId
 	 */
-	void transferItemOwnershipToGroup(String itemId, long groupId);
+	String transferItemOwnershipToGroup(String itemId, long groupId) throws IOException;
 	
 	/**
@@ -244,5 +228,5 @@
 	 * @return
 	 */
-	BaseDescription getComponentDescription(String componentId) throws ComponentRegistryException;
+	BaseDescription getBaseDescription(String componentId) throws ComponentRegistryException, IOException;
 
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/MDValidator.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/MDValidator.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/MDValidator.java	(revision 5549)
@@ -5,9 +5,12 @@
 import clarin.cmdi.componentregistry.ComponentRegistryResourceResolver;
 import clarin.cmdi.componentregistry.Configuration;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
 import clarin.cmdi.componentregistry.MDMarshaller;
+import clarin.cmdi.componentregistry.NullIdException;
+import clarin.cmdi.componentregistry.RegistrySpace;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.components.CMDComponentType;
 import clarin.cmdi.componentregistry.model.BaseDescription;
-import clarin.cmdi.componentregistry.model.ComponentDescription;
 import clarin.cmdi.schema.cmd.Validator.Message;
 import clarin.cmdi.schema.cmd.ValidatorException;
@@ -29,5 +32,5 @@
 
 public class MDValidator implements Validator {
-    
+
     private final static Logger LOG = LoggerFactory.getLogger(MDValidator.class);
     static final String MISMATCH_ERROR = "Cannot register component as a profile or vica versa.";
@@ -36,5 +39,5 @@
     static final String SCHEMA_ERROR = "Error in reading general component schema: ";
     static final String IO_ERROR = "Error while reading specification or general component schema: ";
-    static final String COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR = "referenced component cannot be found in the published components: ";
+    static final String COMPONENT_NOT_REGISTERED_IN_APPROPRIATE_SPACE_ERROR = "referenced component cannot be found in the appropriate registry components: ";
     static final String COMPONENT_REGISTRY_EXCEPTION_ERROR = "An exception occurred while accessing the component registry: ";
     static final String ILLEGAL_ATTRIBUTE_NAME_ERROR = "Illegal attribute name: ";
@@ -47,6 +50,4 @@
     private final BaseDescription description;
     private final ComponentRegistry registry;
-    private final ComponentRegistry userRegistry;
-    private final ComponentRegistry publicRegistry;
     private final MDMarshaller marshaller;
 
@@ -61,20 +62,18 @@
      * @param registry
      */
-    public MDValidator(InputStream input, BaseDescription description, ComponentRegistry registry, ComponentRegistry userRegistry, ComponentRegistry publicRegistry, MDMarshaller marshaller) {
+    public MDValidator(InputStream input, BaseDescription description, ComponentRegistry registry, MDMarshaller marshaller) {
         this.input = input;
         this.description = description;
         this.registry = registry;
-        this.userRegistry = userRegistry;
-        this.publicRegistry = publicRegistry;
         this.marshaller = marshaller;
     }
-    
+
     @Override
     public List<String> getErrorMessages() {
         return errorMessages;
     }
-    
+
     @Override
-    public boolean validate() {
+    public boolean validate() throws UserUnauthorizedException {
         try {
             clarin.cmdi.schema.cmd.Validator validator = new clarin.cmdi.schema.cmd.Validator(new URL(Configuration.getInstance().getGeneralComponentSchema()));
@@ -116,65 +115,88 @@
             } catch (ComponentRegistryException e) {
                 errorMessages.add(COMPONENT_REGISTRY_EXCEPTION_ERROR + e);
+            } catch (ItemNotFoundException e2) {
+                errorMessages.add(COMPONENT_NOT_REGISTERED_ERROR + e2);
+            } catch (NullIdException e3) {
+                errorMessages.add(COMPONENT_NOT_REGISTERED_ERROR + e3);
             }
         }
         return errorMessages.isEmpty();
     }
-    
+
     private byte[] getBytesFromInputStream() throws IOException {
         int len;
         byte[] b = new byte[4096];
         final ByteArrayOutputStream bOS = new ByteArrayOutputStream();
-        
+
         while ((len = input.read(b)) > 0) {
             bOS.write(b, 0, len);
         }
-        
+
         return bOS.toByteArray();
     }
 
-    private void validateComponents(CMDComponentSpec componentSpec) throws ComponentRegistryException {
+    private void validateComponents(CMDComponentSpec componentSpec) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException, NullIdException {
         validateComponents(Collections.singletonList(componentSpec.getCMDComponent()));
     }
-    
-    private void validateComponents(List<CMDComponentType> cmdComponents) throws ComponentRegistryException {
+
+    private void validateComponents(List<CMDComponentType> cmdComponents) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException, NullIdException {
         for (CMDComponentType cmdComponentType : cmdComponents) {
-            validateDescribedComponents(cmdComponentType);
-            validateComponents(cmdComponentType.getCMDComponent());//Recursion
-        }
-    }
-    
-    private void validateDescribedComponents(CMDComponentType cmdComponentType) throws ComponentRegistryException {
-        checkPublicComponents(cmdComponentType);
-    }
-    
-    private void checkPublicComponents(CMDComponentType cmdComponentType) throws ComponentRegistryException {
+            this.validateDescribedComponents(cmdComponentType);
+            this.validateComponents(cmdComponentType.getCMDComponent());//Recursion
+        }
+    }
+
+    private void validateDescribedComponents(CMDComponentType cmdComponentType) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException, NullIdException {
+        this.checkComponentInSpace(cmdComponentType);
+    }
+
+    private void checkComponentInSpace(CMDComponentType cmdComponentType) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException, NullIdException {
         if (isDefinedInSeparateFile(cmdComponentType)) {
             String id = cmdComponentType.getComponentId();
-            CMDComponentSpec registeredComponent;
-            if (registry.isPublic()) { // public registry requires only published components
-                registeredComponent = registry.getMDComponent(id);
-                if (registeredComponent == null) {
-                    String error = cmdComponentType.getComponentId();
-                    if (userRegistry != null) {
-                        ComponentDescription desc = userRegistry.getComponentDescription(id);
-                        if (desc != null) {
-                            error = desc.getName() + " (" + cmdComponentType.getComponentId() + ")";
+            if (id == null) {
+                String name = (cmdComponentType.getName() == null) ? "null" : cmdComponentType.getName();
+                throw new NullIdException("The component with the name " + name + " has a null id. :(");
+            }
+            CMDComponentSpec registeredComponent = registry.getMDComponent(id);
+            if (registeredComponent != null) {
+                String componentId = cmdComponentType.getComponentId();
+                Boolean isPublicB = registry.isItemPublic(id);// throws ItemNotFoundException
+                boolean isPublic = isPublicB.booleanValue();
+                if (isPublic) {  // if  a component is public, it is available for any registry
+                    return;
+                };
+                // a private component for a private registry is available only if its owner is the owner of the resgitry
+                if (registry.getRegistrySpace().equals(RegistrySpace.PRIVATE)) {
+                    Number registryOwnerId = registry.getRegistryOwner().getId();
+                    Number componentOwnerId = registry.getBaseDescriptionOwnerId(cmdComponentType.getComponentId());
+                    if (registryOwnerId.equals(componentOwnerId)) {
+                        return;
+                    };
+                    errorMessages.add(COMPONENT_NOT_REGISTERED_IN_APPROPRIATE_SPACE_ERROR + componentId + " (private registry)");
+                    return;
+
+                } else { // a private component in a group registry is availabe only if it belongs to the group
+                    if (registry.getRegistrySpace().equals(RegistrySpace.GROUP)) {
+                        if (registry.getGroupId() == null) {
+                            errorMessages.add(COMPONENT_REGISTRY_EXCEPTION_ERROR + "in the group space, the group id is null");
+                            return;
                         }
+                        List<Number> componentGroupIds = registry.getItemGroups(cmdComponentType.getComponentId());
+                        if (componentGroupIds.contains(registry.getGroupId())) {
+                            return;
+                        }
+                        errorMessages.add(COMPONENT_NOT_REGISTERED_IN_APPROPRIATE_SPACE_ERROR + componentId + " (group registry) " + registry.getGroupId());
+                        return;
                     }
-                    errorMessages.add(COMPONENT_NOT_PUBLICLY_REGISTERED_ERROR + error);
+                    errorMessages.add(COMPONENT_NOT_REGISTERED_IN_APPROPRIATE_SPACE_ERROR + componentId + " (private component in public registry).");
+                    return;
                 }
-            } else { //User registry, can link to components from public registry and the user's registry
-                registeredComponent = registry.getMDComponent(id);
-                if (registeredComponent == null) {
-                    registeredComponent = publicRegistry.getMDComponent(id);
-                    if (registeredComponent == null) {
-                        errorMessages.add(COMPONENT_NOT_REGISTERED_ERROR + cmdComponentType.getComponentId());
-                    }
-                }
-                
-            }
-        }
-    }
-    
+
+            };
+            errorMessages.add(COMPONENT_NOT_REGISTERED_ERROR + cmdComponentType.getComponentId());
+        }
+
+    }
+
     private boolean isDefinedInSeparateFile(CMDComponentType cmdComponentType) {
         return cmdComponentType.getName() == null;
@@ -195,6 +217,5 @@
      * has validated. If you are not going to alter this copy, you can re-use
      * and share the copy used during validation by getting it from {@link #getCMDComponentSpec()
-     * }.
-     * <em>Do not call before having called {@link #validate() }!</em>
+     * }. <em>Do not call before having called {@link #validate() }!</em>
      *
      * @return a freshly unmarshalled copy of the spec based on the bytes
@@ -209,6 +230,8 @@
         // Re-unmarshall original bytes
         return unmarshalSpec(originalSpecBytes);
-    }
-    
+
+
+    }
+
     private CMDComponentSpec unmarshalSpec(byte[] inputBytes) throws JAXBException {
         return marshaller.unmarshal(CMDComponentSpec.class, new ByteArrayInputStream(inputBytes), null);
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ProfileClosure.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ProfileClosure.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/ProfileClosure.java	(revision 5549)
@@ -3,4 +3,6 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.model.ProfileDescription;
 
@@ -8,6 +10,6 @@
 
     @Override
-    public ProfileDescription getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException {
-        return registry.getProfileDescription(id);
+    public ProfileDescription getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException {
+        return registry.getProfileDescriptionAccessControlled(id);
     }
 
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/PublishAction.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/PublishAction.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/PublishAction.java	(revision 5549)
@@ -4,4 +4,6 @@
 
 import clarin.cmdi.componentregistry.ComponentRegistry;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.model.BaseDescription;
@@ -17,5 +19,5 @@
 
     @Override
-    public int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry) {
+    public int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry) throws UserUnauthorizedException, ItemNotFoundException{
         response.setIsInUserSpace(false);
         return registry.publish(desc, spec, principal);
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegisterAction.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegisterAction.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegisterAction.java	(revision 5549)
@@ -2,4 +2,6 @@
 
 import clarin.cmdi.componentregistry.ComponentRegistry;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.model.BaseDescription;
@@ -8,5 +10,5 @@
 public interface RegisterAction {
 
-    int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry);
+    int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry) throws UserUnauthorizedException, ItemNotFoundException;
 
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegistryClosure.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegistryClosure.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/RegistryClosure.java	(revision 5549)
@@ -3,9 +3,11 @@
 import clarin.cmdi.componentregistry.ComponentRegistry;
 import clarin.cmdi.componentregistry.ComponentRegistryException;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.model.BaseDescription;
 
 public interface RegistryClosure<T extends BaseDescription> {
     
-    T getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException;
+    T getDescription(ComponentRegistry registry, String id) throws ComponentRegistryException,  UserUnauthorizedException, ItemNotFoundException;
 
 
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/UpdateAction.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/UpdateAction.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/UpdateAction.java	(revision 5549)
@@ -1,7 +1,9 @@
 package clarin.cmdi.componentregistry.rest;
 
-import java.security.Principal;
+//import java.security.Principal;
 
 import clarin.cmdi.componentregistry.ComponentRegistry;
+import clarin.cmdi.componentregistry.ItemNotFoundException;
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import clarin.cmdi.componentregistry.components.CMDComponentSpec;
 import clarin.cmdi.componentregistry.model.BaseDescription;
@@ -10,13 +12,13 @@
 public class UpdateAction implements RegisterAction {
     
-    private final Principal principal;
-
-    public UpdateAction(Principal principal) {
-        this.principal = principal;
-    }
+//    private final Principal principal;
+//
+//    public UpdateAction(Principal principal) {
+//        this.principal = principal;
+//    }
     
     @Override
-    public int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry) {
-        return registry.update(desc, spec, principal, false);
+    public int execute(BaseDescription desc, CMDComponentSpec spec, RegisterResponse response, ComponentRegistry registry)  throws UserUnauthorizedException, ItemNotFoundException{
+        return registry.update(desc, spec, false);
     }
 
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/Validator.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/Validator.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rest/Validator.java	(revision 5549)
@@ -1,4 +1,5 @@
 package clarin.cmdi.componentregistry.rest;
 
+import clarin.cmdi.componentregistry.UserUnauthorizedException;
 import java.util.List;
 
@@ -15,5 +16,5 @@
      * Validate and create an error message when something is wrong.
      */
-    public boolean validate();
+    public boolean validate()  throws UserUnauthorizedException;
 
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rss/RssCreator.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rss/RssCreator.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/rss/RssCreator.java	(revision 5549)
@@ -20,10 +20,10 @@
     private String channelTitle;
     private Comparator<T> comparator;
-    protected final boolean userspace;
+    protected final boolean isPrivate;
     private List<T> objs;
     private int limit;
 
-    protected RssCreator(boolean userspace, String baseURI, int limit, List<T> objs) {
-        this.userspace = userspace;
+    protected RssCreator(boolean isPrivate, String baseURI, int limit, List<T> objs) {
+        this.isPrivate = isPrivate;
         this.baseURI = baseURI;
         this.limit = limit;
